<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: SRV_UbicacionClienteDet.xml */
/* Generado: 2021-06-26 00:00:00 */

/* Busqueda de registros de la tabla SRV_UbicacionClienteDet. */
abstract class BaseSRV_UbicacionClienteDetFN extends SRV_UbicacionClienteDetBN
{
    /* Declaracion de constantes */
    const IdUbicacionClienteH = "SRV_UbicacionClienteDet.IdUbicacionClienteH";
    const IdUbicacion = "SRV_UbicacionClienteDet.IdUbicacion";
    const IdTipoDocumento = "SRV_UbicacionClienteDet.IdTipoDocumento";
    const IdCompania = "SRV_UbicacionClienteDet.IdCompania";
    const IdSucursal = "SRV_UbicacionClienteDet.IdSucursal";
    const NumeroDocumento = "SRV_UbicacionClienteDet.NumeroDocumento";
    const DocumentoCod = "SRV_UbicacionClienteDet.DocumentoCod";
    const DocumentoSerie = "SRV_UbicacionClienteDet.DocumentoSerie";
    const DocumentoNumero = "SRV_UbicacionClienteDet.DocumentoNumero";
    const IdPersona = "SRV_UbicacionClienteDet.IdPersona";
    const NombreCompleto = "SRV_UbicacionClienteDet.NombreCompleto";
    const MontoTotal = "SRV_UbicacionClienteDet.MontoTotal";
    const Estado = "SRV_UbicacionClienteDet.Estado";
    const FechaCreacion = "SRV_UbicacionClienteDet.FechaCreacion";
    const UsuarioCreacion = "SRV_UbicacionClienteDet.UsuarioCreacion";
    const FechaModificacion = "SRV_UbicacionClienteDet.FechaModificacion";
    const UsuarioModificacion = "SRV_UbicacionClienteDet.UsuarioModificacion";

    public $a_Condition = array();
    public $a_OrderBy = array();
    public $a_GroupBy = array();
    public $b_Debug = false;

    /* Obtiene una conexion a la base de datos */
    public function getConnect()
    {
        $o_DBConnect = Conexion::getConexion();
        return $o_DBConnect;
    }

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Obtiene la cadena de columas */
    public function getSelectColumns()
    {
        $s_SQLQuery = "SRV_UbicacionClienteDet.IdUbicacionClienteH AS IdUbicacionClienteH, ";
        $s_SQLQuery .= "SRV_UbicacionClienteDet.IdUbicacion AS IdUbicacion, ";
        $s_SQLQuery .= "SRV_UbicacionClienteDet.IdTipoDocumento AS IdTipoDocumento, ";
        $s_SQLQuery .= "SRV_UbicacionClienteDet.IdCompania AS IdCompania, ";
        $s_SQLQuery .= "SRV_UbicacionClienteDet.IdSucursal AS IdSucursal, ";
        $s_SQLQuery .= "SRV_UbicacionClienteDet.NumeroDocumento AS NumeroDocumento, ";
        $s_SQLQuery .= "SRV_UbicacionClienteDet.DocumentoCod AS DocumentoCod, ";
        $s_SQLQuery .= "SRV_UbicacionClienteDet.DocumentoSerie AS DocumentoSerie, ";
        $s_SQLQuery .= "SRV_UbicacionClienteDet.DocumentoNumero AS DocumentoNumero, ";
        $s_SQLQuery .= "SRV_UbicacionClienteDet.IdPersona AS IdPersona, ";
        $s_SQLQuery .= "SRV_UbicacionClienteDet.NombreCompleto AS NombreCompleto, ";
        $s_SQLQuery .= "SRV_UbicacionClienteDet.MontoTotal AS MontoTotal, ";
        $s_SQLQuery .= "SRV_UbicacionClienteDet.Estado AS Estado, ";
        $s_SQLQuery .= "SRV_UbicacionClienteDet.FechaCreacion AS FechaCreacion, ";
        $s_SQLQuery .= "SRV_UbicacionClienteDet.UsuarioCreacion AS UsuarioCreacion, ";
        $s_SQLQuery .= "SRV_UbicacionClienteDet.FechaModificacion AS FechaModificacion, ";
        $s_SQLQuery .= "SRV_UbicacionClienteDet.UsuarioModificacion AS UsuarioModificacion ";
        return $s_SQLQuery;
    }

    /* Establece el condicion de filtro de la lista resultante */
    public function addCondition( $s_Const, $s_Operator, $u_Value, $b_ComSimple = true )
    {
        $this->a_Condition[] = array( "COLUMN" => $s_Const, "OPERATOR" => $s_Operator, "VALUE" => $u_Value, "FLAG_COMILLAS" => $b_ComSimple );
    }

    /* Establece el orden de la lista resultante */
    public function addOrderBy( $s_Const, $b_OrderAsc = true )
    {
        $this->a_OrderBy[] = array( "COLUMN" => $s_Const, "ASC" => $b_OrderAsc );
    }

    /* Establece el orden de la lista resultante */
    public function addGroupBy( $s_Const )
    {
        $this->a_GroupBy[] = array( "COLUMN" => $s_Const );
    }

    /* Establece los valores desde un objeto SRV_UbicacionClienteDetBN */
    public function setByBN( SRV_UbicacionClienteDetBN $o_SRV_UbicacionClienteDetBN )
    {
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getIdUbicacionClienteH() ) )
        {
            $this->setIdUbicacionClienteH( $o_SRV_UbicacionClienteDetBN->getIdUbicacionClienteH() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getIdUbicacion() ) )
        {
            $this->setIdUbicacion( $o_SRV_UbicacionClienteDetBN->getIdUbicacion() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getIdTipoDocumento() ) )
        {
            $this->setIdTipoDocumento( $o_SRV_UbicacionClienteDetBN->getIdTipoDocumento() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_SRV_UbicacionClienteDetBN->getIdCompania() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getIdSucursal() ) )
        {
            $this->setIdSucursal( $o_SRV_UbicacionClienteDetBN->getIdSucursal() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getNumeroDocumento() ) )
        {
            $this->setNumeroDocumento( $o_SRV_UbicacionClienteDetBN->getNumeroDocumento() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getDocumentoCod() ) )
        {
            $this->setDocumentoCod( $o_SRV_UbicacionClienteDetBN->getDocumentoCod() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getDocumentoSerie() ) )
        {
            $this->setDocumentoSerie( $o_SRV_UbicacionClienteDetBN->getDocumentoSerie() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getDocumentoNumero() ) )
        {
            $this->setDocumentoNumero( $o_SRV_UbicacionClienteDetBN->getDocumentoNumero() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getIdPersona() ) )
        {
            $this->setIdPersona( $o_SRV_UbicacionClienteDetBN->getIdPersona() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getNombreCompleto() ) )
        {
            $this->setNombreCompleto( $o_SRV_UbicacionClienteDetBN->getNombreCompleto() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getMontoTotal() ) )
        {
            $this->setMontoTotal( $o_SRV_UbicacionClienteDetBN->getMontoTotal() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getEstado() ) )
        {
            $this->setEstado( $o_SRV_UbicacionClienteDetBN->getEstado() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_SRV_UbicacionClienteDetBN->getFechaCreacion() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_SRV_UbicacionClienteDetBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_SRV_UbicacionClienteDetBN->getFechaModificacion() );
        }
        if ( !is_null( $o_SRV_UbicacionClienteDetBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_SRV_UbicacionClienteDetBN->getUsuarioModificacion() );
        }
    }

    /**
    * @return SRV_UbicacionClienteDetBN|null
    * @throws SQLException
    */
    public function selectByPK( $i_IdUbicacionClienteH, $s_NumeroDocumento )
    {
        if( is_null( $i_IdUbicacionClienteH ) ){ $i_IdUbicacionClienteH = -1; } 
        if( is_null( $s_NumeroDocumento ) ){ $s_NumeroDocumento = '-1'; } 
 
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= $this->getSelectColumns();
        $s_SQLQuery .= "FROM SRV_UbicacionClienteDet ";
        $s_SQLQuery .= "WHERE IdUbicacionClienteH = ".$i_IdUbicacionClienteH." ";
        $s_SQLQuery .= "AND NumeroDocumento = '".$s_NumeroDocumento."' ";
        $s_SQLQuery .= "LIMIT 1;";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_SRV_UbicacionClienteDetBN = null;
        $o_Resource = $this->getConnect();
        $o_Statement = $o_Resource->prepareStatement( $s_SQLQuery );
        $o_ResultSet = $o_Statement->executeQuery();
        $i_NumRows   = $o_ResultSet->getRecordCount();
        if( $i_NumRows > 0 )
        {
            $o_ResultSet->next();
            $a_SQLRow = $o_ResultSet->getRow(); //devuele array
            $o_SRV_UbicacionClienteDetBN = $this->insertObjectBN( $a_SQLRow );
        }
        return $o_SRV_UbicacionClienteDetBN;
    }

    public function buildConsult()
    {
        $s_SQLQuery = "";
        if ( !is_null( $this->getIdUbicacionClienteH() ) ) $s_SQLQuery .= "SRV_UbicacionClienteDet.IdUbicacionClienteH = ".$this->getIdUbicacionClienteH()." AND ";
        if ( !is_null( $this->getIdUbicacion() ) ) $s_SQLQuery .= "SRV_UbicacionClienteDet.IdUbicacion = ".$this->getIdUbicacion()." AND ";
        if ( !is_null( $this->getIdTipoDocumento() ) ) $s_SQLQuery .= "SRV_UbicacionClienteDet.IdTipoDocumento = '".$this->getIdTipoDocumento()."' AND ";
        if ( !is_null( $this->getIdCompania() ) ) $s_SQLQuery .= "SRV_UbicacionClienteDet.IdCompania = ".$this->getIdCompania()." AND ";
        if ( !is_null( $this->getIdSucursal() ) ) $s_SQLQuery .= "SRV_UbicacionClienteDet.IdSucursal = ".$this->getIdSucursal()." AND ";
        if ( !is_null( $this->getNumeroDocumento() ) ) $s_SQLQuery .= "SRV_UbicacionClienteDet.NumeroDocumento = '".$this->getNumeroDocumento()."' AND ";
        if ( !is_null( $this->getDocumentoCod() ) ) $s_SQLQuery .= "SRV_UbicacionClienteDet.DocumentoCod = '".$this->getDocumentoCod()."' AND ";
        if ( !is_null( $this->getDocumentoSerie() ) ) $s_SQLQuery .= "SRV_UbicacionClienteDet.DocumentoSerie = '".$this->getDocumentoSerie()."' AND ";
        if ( !is_null( $this->getDocumentoNumero() ) ) $s_SQLQuery .= "SRV_UbicacionClienteDet.DocumentoNumero = '".$this->getDocumentoNumero()."' AND ";
        if ( !is_null( $this->getIdPersona() ) ) $s_SQLQuery .= "SRV_UbicacionClienteDet.IdPersona = ".$this->getIdPersona()." AND ";
        if ( !is_null( $this->getNombreCompleto() ) ) $s_SQLQuery .= "SRV_UbicacionClienteDet.NombreCompleto = '".$this->getNombreCompleto()."' AND ";
        if ( !is_null( $this->getMontoTotal() ) ) $s_SQLQuery .= "SRV_UbicacionClienteDet.MontoTotal = ".$this->getMontoTotal()." AND ";
        if ( !is_null( $this->getEstado() ) ) $s_SQLQuery .= "SRV_UbicacionClienteDet.Estado = '".$this->getEstado()."' AND ";
        if ( !is_null( $this->getFechaCreacion() ) ) $s_SQLQuery .= "SRV_UbicacionClienteDet.FechaCreacion = '".$this->getFechaCreacion()."' AND ";
        if ( !is_null( $this->getUsuarioCreacion() ) ) $s_SQLQuery .= "SRV_UbicacionClienteDet.UsuarioCreacion = '".$this->getUsuarioCreacion()."' AND ";
        if ( !is_null( $this->getFechaModificacion() ) ) $s_SQLQuery .= "SRV_UbicacionClienteDet.FechaModificacion = '".$this->getFechaModificacion()."' AND ";
        if ( !is_null( $this->getUsuarioModificacion() ) ) $s_SQLQuery .= "SRV_UbicacionClienteDet.UsuarioModificacion = '".$this->getUsuarioModificacion()."' AND ";
        if ( count( $this->a_Condition ) > 0 )
        {
            foreach ( $this->a_Condition as $a_Condition )
            {
                if( $a_Condition['FLAG_COMILLAS'] )
                {
                    $s_SQLQuery .= $a_Condition[ "COLUMN" ]." ".$a_Condition[ "OPERATOR" ]." '".$a_Condition[ "VALUE" ]."' AND ";
                }
                else
                {
                    $s_SQLQuery .= $a_Condition[ "COLUMN" ]." ".$a_Condition[ "OPERATOR" ]." ".$a_Condition[ "VALUE" ]." AND ";
                }
            }
        }
        $s_SQLQuery .= "1 = 1 ";
        return $s_SQLQuery;
    }

    public function selectNumRows()
    {
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= "COUNT(*) AS cnt ";
        $s_SQLQuery .= "FROM SRV_UbicacionClienteDet WHERE ";
        $s_SQLQuery .= $this->buildConsult();
        
        if ( count( $this->a_GroupBy ) > 0 )
        {
            $s_SQLQuery .= "GROUP BY ";
            $s_Separator = "";
            foreach ( $this->a_GroupBy as $a_GroupBy )
            {
                $s_SQLQuery .= $s_Separator.$a_GroupBy[ "COLUMN" ]." ";
                $s_Separator = ", ";
            }
        }
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = $this->getConnect();
        $o_Statement = $o_Resource->prepareStatement( $s_SQLQuery );
        $o_ResultSet = $o_Statement->executeQuery();
        $o_ResultSet->next();
        $i_NumRows    = $o_ResultSet->getInt( 'cnt' );
        return $i_NumRows;
    }

    /**
    * @param null $i_Position
    * @param null $i_Rows
    * @return SRV_UbicacionClienteDetBN[]
    * @throws SQLException
    */
    public function select( $i_Position = null, $i_Rows = null )
    {
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= $this->getSelectColumns();
        $s_SQLQuery .= "FROM SRV_UbicacionClienteDet WHERE ";
        $s_SQLQuery .= $this->buildConsult();
        if ( count( $this->a_GroupBy ) > 0 )
        {
            $s_SQLQuery .= "GROUP BY ";
            $s_Separator = "";
            foreach ( $this->a_GroupBy as $a_GroupBy )
            {
                $s_SQLQuery .= $s_Separator.$a_GroupBy[ "COLUMN" ]." ";
                $s_Separator = ", ";
            }
        }
        if ( count( $this->a_OrderBy ) > 0 )
        {
            $s_SQLQuery = $s_SQLQuery."ORDER BY ";
            $s_Separator = "";
            foreach ( $this->a_OrderBy as $a_OrderBy )
            {
                $s_SQLQuery .= $s_Separator.$a_OrderBy[ "COLUMN" ]." ";
                if ( $a_OrderBy[ "ASC" ] === false ) $s_SQLQuery .= "DESC ";
                $s_Separator = ", ";
            }
        }
        if( !is_null( $i_Position ) && is_null( $i_Rows ) ) $s_SQLQuery .= "LIMIT ".$i_Position;
        if( !is_null( $i_Position ) && !is_null( $i_Rows ) ) $s_SQLQuery .= "LIMIT ".$i_Position.", ".$i_Rows;
        $s_SQLQuery .= ";";

        if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        $a_SRV_UbicacionClienteDetBN = array();
        $o_Resource = $this->getConnect();
        $o_Statement = $o_Resource->prepareStatement( $s_SQLQuery );
        $o_ResultSet = $o_Statement->executeQuery();
        $i_NumRows = $o_ResultSet->getRecordCount();
        if( $i_NumRows > 0 )
        {
            while( $o_ResultSet->next() ) 
            {
                $a_SQLRow = $o_ResultSet->getRow(); //devuele array
                $o_SRV_UbicacionClienteDetBN = $this->insertObjectBN( $a_SQLRow );
                $a_SRV_UbicacionClienteDetBN[] = $o_SRV_UbicacionClienteDetBN;
            }
        }
        return $a_SRV_UbicacionClienteDetBN;
    }

    /* Devuelve un objeto SRV_UbicacionClienteDetBN desde un objeto propel */
    public function insertObjectBN( $a_SRV_UbicacionClienteDet )
    {
        $o_SRV_UbicacionClienteDetBN = new SRV_UbicacionClienteDetBN();
        if ( !is_null( $a_SRV_UbicacionClienteDet['IdUbicacionClienteH'] ) ) $o_SRV_UbicacionClienteDetBN->setIdUbicacionClienteH( ( integer ) $a_SRV_UbicacionClienteDet['IdUbicacionClienteH'] );
        if ( !is_null( $a_SRV_UbicacionClienteDet['IdUbicacion'] ) ) $o_SRV_UbicacionClienteDetBN->setIdUbicacion( ( integer ) $a_SRV_UbicacionClienteDet['IdUbicacion'] );
        if ( !is_null( $a_SRV_UbicacionClienteDet['IdTipoDocumento'] ) ) $o_SRV_UbicacionClienteDetBN->setIdTipoDocumento( $a_SRV_UbicacionClienteDet['IdTipoDocumento'] );
        if ( !is_null( $a_SRV_UbicacionClienteDet['IdCompania'] ) ) $o_SRV_UbicacionClienteDetBN->setIdCompania( ( integer ) $a_SRV_UbicacionClienteDet['IdCompania'] );
        if ( !is_null( $a_SRV_UbicacionClienteDet['IdSucursal'] ) ) $o_SRV_UbicacionClienteDetBN->setIdSucursal( ( integer ) $a_SRV_UbicacionClienteDet['IdSucursal'] );
        if ( !is_null( $a_SRV_UbicacionClienteDet['NumeroDocumento'] ) ) $o_SRV_UbicacionClienteDetBN->setNumeroDocumento( $a_SRV_UbicacionClienteDet['NumeroDocumento'] );
        if ( !is_null( $a_SRV_UbicacionClienteDet['DocumentoCod'] ) ) $o_SRV_UbicacionClienteDetBN->setDocumentoCod( $a_SRV_UbicacionClienteDet['DocumentoCod'] );
        if ( !is_null( $a_SRV_UbicacionClienteDet['DocumentoSerie'] ) ) $o_SRV_UbicacionClienteDetBN->setDocumentoSerie( $a_SRV_UbicacionClienteDet['DocumentoSerie'] );
        if ( !is_null( $a_SRV_UbicacionClienteDet['DocumentoNumero'] ) ) $o_SRV_UbicacionClienteDetBN->setDocumentoNumero( $a_SRV_UbicacionClienteDet['DocumentoNumero'] );
        if ( !is_null( $a_SRV_UbicacionClienteDet['IdPersona'] ) ) $o_SRV_UbicacionClienteDetBN->setIdPersona( ( integer ) $a_SRV_UbicacionClienteDet['IdPersona'] );
        if ( !is_null( $a_SRV_UbicacionClienteDet['NombreCompleto'] ) ) $o_SRV_UbicacionClienteDetBN->setNombreCompleto( $a_SRV_UbicacionClienteDet['NombreCompleto'] );
        if ( !is_null( $a_SRV_UbicacionClienteDet['MontoTotal'] ) ) $o_SRV_UbicacionClienteDetBN->setMontoTotal( ( float ) $a_SRV_UbicacionClienteDet['MontoTotal'] );
        if ( !is_null( $a_SRV_UbicacionClienteDet['Estado'] ) ) $o_SRV_UbicacionClienteDetBN->setEstado( $a_SRV_UbicacionClienteDet['Estado'] );
        if ( !is_null( $a_SRV_UbicacionClienteDet['FechaCreacion'] ) ) $o_SRV_UbicacionClienteDetBN->setFechaCreacion( utilTimestamp::getTimestamp( $a_SRV_UbicacionClienteDet['FechaCreacion'], "Y-m-d H:i:s" ) );
        if ( !is_null( $a_SRV_UbicacionClienteDet['UsuarioCreacion'] ) ) $o_SRV_UbicacionClienteDetBN->setUsuarioCreacion( $a_SRV_UbicacionClienteDet['UsuarioCreacion'] );
        if ( !is_null( $a_SRV_UbicacionClienteDet['FechaModificacion'] ) ) $o_SRV_UbicacionClienteDetBN->setFechaModificacion( utilTimestamp::getTimestamp( $a_SRV_UbicacionClienteDet['FechaModificacion'], "Y-m-d H:i:s" ) );
        if ( !is_null( $a_SRV_UbicacionClienteDet['UsuarioModificacion'] ) ) $o_SRV_UbicacionClienteDetBN->setUsuarioModificacion( $a_SRV_UbicacionClienteDet['UsuarioModificacion'] );
        return $o_SRV_UbicacionClienteDetBN;
    }
}
?>